# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#    Copyright (C) 2012 Mentis d.o.o.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
import decimal_precision as dp

class stock_move(osv.osv):
    _inherit = "stock.move"
    
    def action_confirm(self, cr, uid, ids, context=None):
        _delivered_qty = 0.0
        moves = self.browse(cr, uid, ids, context=context)
        for move in moves:
            if move.picking_id.type == 'out':
                if move.product_qty_returned > move.product_qty:
                    move.product_qty_returned = move.product_qty
                    self.write(cr, uid, [move.id], {'product_qty_returned': move.product_qty_returned})
                _delivered_qty = move.product_qty - move.product_qty_returned
                self.write(cr, uid, [move.id], {'product_qty': _delivered_qty})

        return super(stock_move, self).action_confirm(cr, uid, ids, context)
    
    
    _columns = {
        'product_qty_returned': fields.float('Quantity Returned', digits_compute=dp.get_precision('Purchase Price'), ),
    }
    _defaults = {
        'product_qty_returned': 0.0
    }

stock_move()
